import { Column } from '@devexpress/dx-react-grid';
import { ColumnChooser as ColumnChooser_2 } from '@devexpress/dx-react-grid';
import { DragDropProvider as DragDropProvider_2 } from '@devexpress/dx-react-grid';
import { ExportPanel as ExportPanel_2 } from '@devexpress/dx-react-grid';
import { Grid as Grid_2 } from '@devexpress/dx-react-grid';
import { GroupingPanel as GroupingPanel_2 } from '@devexpress/dx-react-grid';
import { PagingPanel as PagingPanel_2 } from '@devexpress/dx-react-grid';
import * as React_2 from 'react';
import { SearchPanel as SearchPanel_2 } from '@devexpress/dx-react-grid';
import { Table as Table_2 } from '@devexpress/dx-react-grid';
import { TableBandHeader as TableBandHeader_2 } from '@devexpress/dx-react-grid';
import { TableColumnResizing as TableColumnResizing_2 } from '@devexpress/dx-react-grid';
import { TableColumnVisibility as TableColumnVisibility_2 } from '@devexpress/dx-react-grid';
import { TableColumnWidthInfo } from '@devexpress/dx-react-grid';
import { TableEditColumn as TableEditColumn_2 } from '@devexpress/dx-react-grid';
import { TableEditRow as TableEditRow_2 } from '@devexpress/dx-react-grid';
import { TableFilterRow as TableFilterRow_2 } from '@devexpress/dx-react-grid';
import { TableFixedColumns as TableFixedColumns_2 } from '@devexpress/dx-react-grid';
import { TableGroupRow as TableGroupRow_2 } from '@devexpress/dx-react-grid';
import { TableHeaderRow as TableHeaderRow_2 } from '@devexpress/dx-react-grid';
import { TableInlineCellEditing as TableInlineCellEditing_2 } from '@devexpress/dx-react-grid';
import { TableKeyboardNavigation as TableKeyboardNavigation_2 } from '@devexpress/dx-react-grid';
import { TableRowDetail as TableRowDetail_2 } from '@devexpress/dx-react-grid';
import { TableSelection as TableSelection_2 } from '@devexpress/dx-react-grid';
import { TableSummaryRow as TableSummaryRow_2 } from '@devexpress/dx-react-grid';
import { TableTreeColumn as TableTreeColumn_2 } from '@devexpress/dx-react-grid';
import { Toolbar as Toolbar_2 } from '@devexpress/dx-react-grid';
import { VirtualTable as VirtualTable_2 } from '@devexpress/dx-react-grid';

export declare namespace ColumnChooser {
  /** Describes properties passed to a component that renders the column chooser overlay. */
  export type OverlayProps = ColumnChooser_2.OverlayProps;
}

export declare namespace ColumnChooser {
  /** Describes properties passed to a component that renders the button that invokes the column chooser. */
  export type ToggleButtonProps = ColumnChooser_2.ToggleButtonProps;
}

export declare namespace ColumnChooser {
  /** Describes properties passed to a component that renders the column chooser container. */
  export type ContainerProps = ColumnChooser_2.ContainerProps;
}

export declare namespace ColumnChooser {
  /** Describes properties passed to a component that renders a column chooser item. */
  export type ItemProps = ColumnChooser_2.ItemProps;
}

/** The ColumnChooser plugin allows a user to toggle grid columns' visibility at runtime. The column chooser lists columns with checkboxes that control a corresponding column's visibility. */
export declare const ColumnChooser: React_2.ComponentType<ColumnChooserProps> & {
  /** A component that renders a button that invokes the column chooser. */
  ToggleButton: React_2.ComponentType<ColumnChooser_2.ToggleButtonProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the column chooser overlay. */
  Overlay: React_2.ComponentType<ColumnChooser_2.OverlayProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the column chooser container. */
  Container: React_2.ComponentType<ColumnChooser_2.ContainerProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a column chooser item. */
  Item: React_2.ComponentType<ColumnChooser_2.ItemProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ColumnChooserProps {
  /** A component that renders the column chooser overlay. */
  overlayComponent?: React_2.ComponentType<ColumnChooser_2.OverlayProps>;
  /** A component that renders a button that invokes the column chooser. */
  toggleButtonComponent?: React_2.ComponentType<ColumnChooser_2.ToggleButtonProps>;
  /** A component that renders the column chooser container. */
  containerComponent?: React_2.ComponentType<ColumnChooser_2.ContainerProps>;
  /** A component that renders a column chooser item. */
  itemComponent?: React_2.ComponentType<ColumnChooser_2.ItemProps>;
  /** An object that specifies localization messages. */
  messages?: ColumnChooser_2.LocalizationMessages;
}

export declare namespace DragDropProvider {
  /** Describes properties of the component that renders a container for columns being dragged. */
  export type ContainerProps = DragDropProvider_2.ContainerProps;
}

export declare namespace DragDropProvider {
  /** Describes properties of the component that renders a column being dragged. */
  export type ColumnProps = DragDropProvider_2.ColumnProps;
}

/** A plugin that implements the drag-and-drop functionality and visualizes columns that are being dragged. */
export declare const DragDropProvider: React_2.ComponentType<DragDropProviderProps> & {
  /** A component that renders a container for columns being dragged. */
  Container: React_2.ComponentType<DragDropProvider_2.ContainerProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a column being dragged. */
  Column: React_2.ComponentType<DragDropProvider_2.ColumnProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface DragDropProviderProps {
  /** A component that renders a container for columns being dragged. */
  containerComponent?: React_2.ComponentType<DragDropProvider_2.ContainerProps>;
  /** A component that renders a column being dragged. */
  columnComponent?: React_2.ComponentType<DragDropProvider_2.ColumnProps>;
}

export declare namespace ExportPanel {
  /** Properties passed to the `toggleButtonComponent`. */
  export type ToggleButtonProps = ExportPanel_2.ToggleButtonProps;
}

export declare namespace ExportPanel {
  /** Properties passed to the `menuComponent`. */
  export type MenuProps = ExportPanel_2.MenuProps;
}

export declare namespace ExportPanel {
  /** Properties passed to the `menuItemComponent`. */
  export type MenuItemProps = ExportPanel_2.MenuItemProps;
}

/** A plugin that renders the Export Panel. */
export declare const ExportPanel: React_2.ComponentType<ExportPanelProps> & {
  /** A component that renders a button that opens the export menu. */
  ToggleButton: React_2.ComponentType<ExportPanel_2.ToggleButtonProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the export menu. */
  Menu: React_2.ComponentType<ExportPanel_2.MenuProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a menu item. */
  MenuItem: React_2.ComponentType<ExportPanel_2.MenuItemProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ExportPanelProps {
  /** A component that renders a button that opens the export menu. */
  toggleButtonComponent?: React_2.ComponentType<ExportPanel_2.ToggleButtonProps>;
  /** A component that renders the export menu. */
  menuComponent?: React_2.ComponentType<ExportPanel_2.MenuProps>;
  /** A component that renders a menu item. */
  menuItemComponent?: React_2.ComponentType<ExportPanel_2.MenuItemProps>;
  /** A function that initiates the export. */
  startExport?: (options: object) => void;
  /** Localization messages. */
  messages?: ExportPanel_2.LocalizationMessages;
}

export declare namespace Grid {
  /** Describes properties passed to a component that renders the grid root layout. */
  export type RootProps = Grid_2.RootProps;
}

/** The Grid is a root container component designed to process and display data specified via the `rows` property. You can use the `columns` property to configure columns.The Grid's functionality  is implemented in several plugins specified as child components.The Grid is a PluginHost and can contain only other plugins and plugin primitives. */
export declare const Grid: React_2.ComponentType<GridProps> & {
  /** A component that renders the grid root layout. */
  Root: React_2.ComponentType<Grid_2.RootProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface GridProps {
  /** An array containing custom data. A user defines the access to this data. Refer to Data Accessors for details. */
  rows: ReadonlyArray<any>;
  /** Specifies for which row fields columns are created. */
  columns: ReadonlyArray<Column>;
  /** Specifies the function used to get a unique row identifier. Define this function if the identifier is different than the row index. */
  getRowId?: (row: any) => number | string;
  /** Specifies the function used to get a cell's value. */
  getCellValue?: (row: any, columnName: string) => any;
  /** A component that renders the grid root layout. */
  rootComponent?: React_2.ComponentType<Grid_2.RootProps>;
}

export declare namespace GroupingPanel {
  /** Describes properties passed to a component that renders a group panel container. */
  export type ContainerProps = GroupingPanel_2.ContainerProps;
}

export declare namespace GroupingPanel {
  /** Describes properties passed to a group panel item template when it is being rendered. */
  export type ItemProps = GroupingPanel_2.ItemProps;
}

export declare namespace GroupingPanel {
  /** Describes properties passed to a component that renders an empty group panel message. */
  export type EmptyMessageProps = GroupingPanel_2.EmptyMessageProps;
}

/** A plugin that renders the Grouping Panel in the Grid's header. This panel displays grouped columns and allows a user to modify grouping options.Optionally, the plugin allows an end-user to change grouped columns' sorting order and render sorting indicators. */
export declare const GroupingPanel: React_2.ComponentType<GroupingPanelProps> & {
  /** A component that renders a grouping panel container. */
  Container: React_2.ComponentType<GroupingPanel_2.ContainerProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a grouping panel item. */
  Item: React_2.ComponentType<GroupingPanel_2.ItemProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders an empty grouping panel message. */
  EmptyMessage: React_2.ComponentType<GroupingPanel_2.EmptyMessageProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface GroupingPanelProps {
  /** Specifies whether to render controls that toggle the column's sorting state. Requires the SortingState dependency. */
  showSortingControls?: boolean;
  /** Specifies whether column headers display a button that cancels grouping by that column. */
  showGroupingControls?: boolean;
  /** A component that renders a group panel container. */
  containerComponent?: React_2.ComponentType<GroupingPanel_2.ContainerProps>;
  /** A component that renders a group panel item. */
  itemComponent?: React_2.ComponentType<GroupingPanel_2.ItemProps>;
  /** A component that renders an empty group panel message. */
  emptyMessageComponent?: React_2.ComponentType<GroupingPanel_2.EmptyMessageProps>;
  /** An object that specifies the localization messages. */
  messages?: GroupingPanel_2.LocalizationMessages;
}

export declare namespace PagingPanel {
  /** Describes the container component properties. */
  export type ContainerProps = PagingPanel_2.ContainerProps;
}

/** A plugin that renders the paging panel used for navigation through data pages. The panel occupies the entire Grid footer. */
export declare const PagingPanel: React_2.ComponentType<PagingPanelProps> & {
  /** A component that renders the paging panel. */
  Container: React_2.ComponentType<PagingPanel_2.ContainerProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface PagingPanelProps {
  /** A component that renders the paging panel. */
  containerComponent?: React_2.ComponentType<PagingPanel_2.ContainerProps>;
  /** The page sizes that a user can select. */
  pageSizes?: Array<number>;
  /** An object that specifies the localization messages. */
  messages?: PagingPanel_2.LocalizationMessages;
}

export declare namespace SearchPanel {
  /** Describes properties passed to a component that renders the Search Panel root element. */
  export type InputProps = SearchPanel_2.InputProps;
}

/** A plugin that renders the Search Panel. */
export declare const SearchPanel: React_2.ComponentType<SearchPanelProps> & {
  /** A component that renders the Search Panel input element. */
  Input: React_2.ComponentType<SearchPanel_2.InputProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface SearchPanelProps {
  /** A component that renders the Search Panel input element. */
  inputComponent?: React_2.ComponentType<SearchPanel_2.InputProps>;
  /** An object that specifies localization messages. */
  messages?: SearchPanel_2.LocalizationMessages;
}

export declare namespace Table {
  /** Describes additional column properties that the plugin can handle. */
  export type ColumnExtension = Table_2.ColumnExtension;
}

export declare namespace Table {
  /** Describes properties passed to a component that renders a generic table cell. */
  export type CellProps = Table_2.CellProps;
}

export declare namespace Table {
  /** Describes properties passed to a component that renders a table cell. */
  export type DataCellProps = Table_2.DataCellProps;
}

export declare namespace Table {
  /** Describes properties passed to a component that renders a table cell when the table is empty. */
  export type NoDataCellProps = Table_2.NoDataCellProps;
}

export declare namespace Table {
  /** Describes properties passed to a component that renders a generic table row. */
  export type RowProps = Table_2.RowProps;
}

export declare namespace Table {
  /** Describes properties passed to a component that renders a table row. */
  export type DataRowProps = Table_2.DataRowProps;
}

/** A plugin that renders Grid data as a table. This plugin enables you to customize table rows and columns, and contains the Table Row and Table Cell components that can be extended by other plugins */
export declare const Table: React_2.ComponentType<TableProps> & {
  /** The data column type's indentifier. */
  COLUMN_TYPE: symbol;
  /** The data row type's indentifier. */
  ROW_TYPE: symbol;
  /** The nodata row type's indentifier. */
  NODATA_ROW_TYPE: symbol;
} & {
  /** A component that renders a table. */
  Table: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table head. */
  TableHead: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table body. */
  TableBody: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table's container. */
  Container: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table data cell. */
  Cell: React_2.ComponentType<Table_2.DataCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table data row. */
  Row: React_2.ComponentType<Table_2.DataRowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table cell when the table is empty. */
  NoDataCell: React_2.ComponentType<Table_2.NoDataCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table row when the table is empty. */
  NoDataRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a stub table row. */
  StubRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a stub table cell. */
  StubCell: React_2.ComponentType<Table_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a stub table header cell. */
  StubHeaderCell: React_2.ComponentType<Table_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare namespace TableBandHeader {
  /** Describes properties passed to a component that renders a table band cell. */
  export type CellProps = TableBandHeader_2.CellProps;
}

export declare namespace TableBandHeader {
  /** Describes properties of column bands that the TableBandHeader plugin renders. */
  export type ColumnBands = TableBandHeader_2.ColumnBands;
}

/** A plugin that renders the banded cells. */
export declare const TableBandHeader: React_2.ComponentType<TableBandHeaderProps> & {
  /** The band row type's identifier. */
  ROW_TYPE: symbol;
} & {
  /** A component that renders a band cell. */
  Cell: React_2.ComponentType<Table_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a band cells' row. */
  Row: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableBandHeaderProps {
  /** A component that renders a band cell. */
  cellComponent?: React_2.ComponentType<TableBandHeader_2.CellProps>;
  /** A component that renders a band cells' row. */
  rowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** Specifies column bands for multi-level table header. */
  columnBands?: Array<TableBandHeader_2.ColumnBands>;
}

/** A plugin that manages the displayed columns' order. */
export declare const TableColumnReordering: React_2.ComponentType<TableColumnReorderingProps>;

export declare interface TableColumnReorderingProps {
  /** The column order. */
  order?: Array<string>;
  /** The initial column order in the uncontrolled mode. */
  defaultOrder?: Array<string>;
  /** Handles changes to the column order. */
  onOrderChange?: (nextOrder: Array<string>) => void;
}

export declare namespace TableColumnResizing {
  /** Describes additional column properties that the plugin can handle. */
  export type ColumnExtension = TableColumnResizing_2.ColumnExtension;
}

/** A plugin that manages table column widths. */
export declare const TableColumnResizing: React_2.ComponentType<TableColumnResizingProps>;

export declare interface TableColumnResizingProps {
  /** Specifies column widths. */
  columnWidths?: Array<TableColumnWidthInfo>;
  /** Specifies a column's minimum width. */
  minColumnWidth?: number;
  /** Specifies a column's maximum width. */
  maxColumnWidth?: number;
  /** Specifies initial column widths in uncontrolled mode. */
  defaultColumnWidths?: Array<TableColumnWidthInfo>;
  /** Handles column width changes. */
  onColumnWidthsChange?: (nextColumnWidths: Array<TableColumnWidthInfo>) => void;
  /** Additional column properties that the plugin can handle. */
  columnExtensions?: Array<TableColumnResizing_2.ColumnExtension>;
  /** Specifies the resizing mode: `widget` or `nextColumn`. In `widget` mode, `auto` and percentage values cannot be used to specify column widths. */
  resizingMode?: string;
}

export declare namespace TableColumnVisibility {
  /** Describes the empty message component's properties. */
  export type EmptyMessageProps = TableColumnVisibility_2.EmptyMessageProps;
}

export declare namespace TableColumnVisibility {
  /** Describes additional column properties that the plugin can handle. */
  export type ColumnExtension = TableColumnVisibility_2.ColumnExtension;
}

/** A plugin that manages Grid columns' visibility. */
export declare const TableColumnVisibility: React_2.ComponentType<TableColumnVisibilityProps> & {
  /** A component that renders a message displayed when all columns are hidden. */
  EmptyMessage: React_2.ComponentType<TableColumnVisibility_2.EmptyMessageProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableColumnVisibilityProps {
  /** Hidden column names. */
  hiddenColumnNames?: Array<string>;
  /** Names of initially hidden columns in the uncontrolled mode. */
  defaultHiddenColumnNames?: Array<string>;
  /** Specifies whether an end-user can change column visibility. */
  columnTogglingEnabled?: boolean;
  /** Additional column properties that the plugin can handle. */
  columnExtensions?: Array<TableColumnVisibility_2.ColumnExtension>;
  /** Handles hidden columns adding or removing. */
  onHiddenColumnNamesChange?: (hiddenColumnNames: Array<string>) => void;
  /** A component that renders a message that is displayed when all columns are hidden. */
  emptyMessageComponent?: React_2.ComponentType<TableColumnVisibility_2.EmptyMessageProps>;
  /** An object that specifies localization messages. */
  messages?: TableColumnVisibility_2.LocalizationMessages;
}

export declare namespace TableEditColumn {
  /** Describes properties passed to a data row's command cell component. */
  export type CellProps = TableEditColumn_2.CellProps;
}

export declare namespace TableEditColumn {
  /** Describes properties passed to a component that renders a command cell within the header row. */
  export type HeaderCellProps = TableEditColumn_2.HeaderCellProps;
}

export declare namespace TableEditColumn {
  /** Describes properties passed to a component that renders command control within a command cell. */
  export type CommandProps = TableEditColumn_2.CommandProps;
}

/** A plugin that renders a command column. This column contains controls used for row editing, creating, or deleting and committing/canceling changes. */
export declare const TableEditColumn: React_2.ComponentType<TableEditColumnProps> & {
  /** The edit column type's identifier. */
  COLUMN_TYPE: symbol;
} & {
  /** A component that renders a command control within a command cell. */
  Command: React_2.ComponentType<TableEditColumn_2.CommandProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a command cell within a data row. */
  Cell: React_2.ComponentType<TableEditColumn_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a command cell within the header row. */
  HeaderCell: React_2.ComponentType<TableEditColumn_2.HeaderCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableEditColumnProps {
  /** A component that renders a command cell within a data row. */
  cellComponent?: React_2.ComponentType<TableEditColumn_2.CellProps>;
  /** A component that renders a command cell within the header row. */
  headerCellComponent?: React_2.ComponentType<TableEditColumn_2.HeaderCellProps>;
  /** A component that renders command control within a command cell. */
  commandComponent?: React_2.ComponentType<TableEditColumn_2.CommandProps>;
  /** Specifies whether to render the 'New' command within the header row's command cell. */
  showAddCommand?: boolean;
  /** Specifies whether to render the 'Edit' command within the data row's command cell. */
  showEditCommand?: boolean;
  /** Specifies whether to render the 'Delete' command within the data row's command cell. */
  showDeleteCommand?: boolean;
  /** Specifies the command column's width. */
  width?: number | string;
  /** An object that specifies the localization messages. */
  messages?: TableEditColumn_2.LocalizationMessages;
}

export declare namespace TableEditRow {
  /** Describes properties passed to a component that renders an editable cell. */
  export type CellProps = TableEditRow_2.CellProps;
}

export declare namespace TableEditRow {
  /** Describes properties passed to a component that renders an editable row. */
  export type RowProps = TableEditRow_2.RowProps;
}

/** A plugin that renders a row being edited. */
export declare const TableEditRow: React_2.ComponentType<TableEditRowProps> & {
  /** The added row type's identifier. */
  ADDED_ROW_TYPE: symbol;
  /** The edit row type's identifier. */
  EDIT_ROW_TYPE: symbol;
} & {
  /** A component that renders an editable cell. */
  Cell: React_2.ComponentType<TableEditRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders an editable row. */
  Row: React_2.ComponentType<TableEditRow_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableEditRowProps {
  /** A component that renders an editable cell. */
  cellComponent?: React_2.ComponentType<TableEditRow_2.CellProps>;
  /** A component that renders an editable row. */
  rowComponent?: React_2.ComponentType<TableEditRow_2.RowProps>;
  /** Specifies the editable row's height. */
  rowHeight?: number;
}

export declare namespace TableFilterRow {
  /** Describes properties passed to a component that renders a filter cell. */
  export type CellProps = TableFilterRow_2.CellProps;
}

export declare namespace TableFilterRow {
  /** Describes properties passed to a component that renders a filter selector. */
  export type FilterSelectorProps = TableFilterRow_2.FilterSelectorProps;
}

export declare namespace TableFilterRow {
  /** Describes properties passed to a component that renders a filter selector icon. */
  export type IconProps = TableFilterRow_2.IconProps;
}

export declare namespace TableFilterRow {
  /** Describes properties passed to a component that renders a filter editor. */
  export type EditorProps = TableFilterRow_2.EditorProps;
}

export declare namespace TableFilterRow {
  /** Describes properties passed to a component that renders a toggle button for a filter selector. */
  export type ToggleButtonProps = TableFilterRow_2.ToggleButtonProps;
}

/** A plugin that renders a filter row. */
export declare const TableFilterRow: React_2.ComponentType<TableFilterRowProps> & {
  /** The filter row type's identifier. */
  ROW_TYPE: symbol;
} & {
  /** A component that renders a filter row cell. */
  Cell: React_2.ComponentType<TableFilterRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a filter row. */
  Row: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a filter selector. */
  FilterSelector: React_2.ComponentType<TableFilterRow_2.FilterSelectorProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders filter selector icons. */
  Icon: React_2.ComponentType<TableFilterRow_2.IconProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a filter editor. */
  Editor: React_2.ComponentType<TableFilterRow_2.EditorProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a filter selector's toggle button. */
  ToggleButton: React_2.ComponentType<TableFilterRow_2.ToggleButtonProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableFilterRowProps {
  /** A component that renders a filter cell. */
  cellComponent?: React_2.ComponentType<TableFilterRow_2.CellProps>;
  /** A component that renders a filter row. */
  rowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a filter selector. */
  filterSelectorComponent?: React_2.ComponentType<TableFilterRow_2.FilterSelectorProps>;
  /** A component that renders filter selector icons. */
  iconComponent?: React_2.ComponentType<TableFilterRow_2.IconProps>;
  /** A component that renders a filter editor. */
  editorComponent?: React_2.ComponentType<TableFilterRow_2.EditorProps>;
  /** A component that renders a filter selector's toggle button. */
  toggleButtonComponent?: React_2.ComponentType<TableFilterRow_2.ToggleButtonProps>;
  /** Specifies whether the FilterSelector should be displayed. */
  showFilterSelector?: boolean;
  /** The filter row's height. */
  rowHeight?: number;
  /** An object that specifies localization messages. */
  messages?: TableFilterRow_2.LocalizationMessages;
}

export declare namespace TableFixedColumns {
  /** Describes properties passed to a component that renders a fixed column's cell. */
  export type CellProps = TableFixedColumns_2.CellProps;
}

/** A plugin that enables you to fix columns to the left and right sides of the grid. */
export declare const TableFixedColumns: React_2.ComponentType<TableFixedColumnsProps> & {
  /** A component that renders a cell related to a fixed column. */
  Cell: React_2.ComponentType<TableFixedColumns_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableFixedColumnsProps {
  /** Specifies names and types of the columns to be fixed to the left grid's side. */
  leftColumns?: Array<string | symbol>;
  /** Specifies names and types of the columns to be fixed to the right grid's side. */
  rightColumns?: Array<string | symbol>;
  /** A component that renders a fixed column's cell. */
  cellComponent?: React_2.ComponentType<TableFixedColumns_2.CellProps>;
}

export declare namespace TableGroupRow {
  /** Describes additional column properties that the plugin can handle. */
  export type ColumnExtension = TableGroupRow_2.ColumnExtension;
}

export declare namespace TableGroupRow {
  /** Describes a summary item to be displayed in a group caption. */
  export type InlineSummaryItemInfo = TableGroupRow_2.InlineSummaryItemInfo;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a group cell. */
  export type CellProps = TableGroupRow_2.CellProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a group row. */
  export type RowProps = TableGroupRow_2.RowProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a group cell content. */
  export type ContentProps = TableGroupRow_2.ContentProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a group expand icon. */
  export type IconProps = TableGroupRow_2.IconProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a group indent cell. */
  export type IndentCellProps = TableGroupRow_2.IndentCellProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a container for summary items to be displayed in a group caption. */
  export type InlineSummaryProps = TableGroupRow_2.InlineSummaryProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a summary item in a group caption. */
  export type InlineSummaryItemProps = TableGroupRow_2.InlineSummaryItemProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a cell for a summary item in an appropriate column. */
  export type SummaryCellProps = TableGroupRow_2.SummaryCellProps;
}

export declare namespace TableGroupRow {
  /** Describes properties passed to a component that renders a stub cell used to align summary items in their columns. */
  export type StubCellProps = TableGroupRow_2.StubCellProps;
}

/** A plugin that renders group rows and enables them to expand and collapse. */
export declare const TableGroupRow: React_2.ComponentType<TableGroupRowProps> & {
  /** The group column type's identifier. */
  COLUMN_TYPE: symbol;
  /** The group row type's identifier. */
  ROW_TYPE: symbol;
} & {
  /** A component that renders a group row. */
  Row: React_2.ComponentType<TableGroupRow_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group cell. */
  Cell: React_2.ComponentType<TableGroupRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group cell content. */
  Content: React_2.ComponentType<TableGroupRow_2.ContentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group expand icon. */
  Icon: React_2.ComponentType<TableGroupRow_2.IconProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a container for group summary items in a group caption. */
  InlineSummary: React_2.ComponentType<TableGroupRow_2.InlineSummaryProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a single group summary item in a group caption. */
  InlineSummaryItem: React_2.ComponentType<TableGroupRow_2.InlineSummaryItemProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a cell for a group summary item in an appropriate column. */
  SummaryCell: React_2.ComponentType<TableGroupRow_2.SummaryCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group summary item in its column. */
  SummaryItem: React_2.ComponentType<TableSummaryRow_2.ItemProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableGroupRowProps {
  /** A Boolean value that specifies whether the grid's table displays a column by which data is grouped. */
  showColumnsWhenGrouped?: boolean;
  /** Additional column properties that the plugin can handle. */
  columnExtensions?: Array<TableGroupRow_2.ColumnExtension>;
  /** A component that renders a group cell. */
  cellComponent?: React_2.ComponentType<TableGroupRow_2.CellProps>;
  /** A component that renders a group row. */
  rowComponent?: React_2.ComponentType<TableGroupRow_2.RowProps>;
  /** A component that renders a group cell content. */
  contentComponent?: React_2.ComponentType<TableGroupRow_2.ContentProps>;
  /** A component that renders a group expand icon. */
  iconComponent?: React_2.ComponentType<TableGroupRow_2.IconProps>;
  /** A component that renders a group indent cell. */
  indentCellComponent?: React_2.ComponentType<TableGroupRow_2.IndentCellProps>;
  /** A component that renders a container for group summary items in a group caption. */
  inlineSummaryComponent?: React_2.ComponentType<TableGroupRow_2.InlineSummaryProps>;
  /** A component that renders a single group summary item in a group caption. */
  inlineSummaryItemComponent?: React_2.ComponentType<TableGroupRow_2.InlineSummaryItemProps>;
  /** A component that renders a cell for a group summary item in an appropriate column. */
  summaryCellComponent?: React_2.ComponentType<TableGroupRow_2.SummaryCellProps>;
  /** A component that renders a group summary item in its column. */
  summaryItemComponent?: React_2.ComponentType<TableSummaryRow_2.ItemProps>;
  /** A component that renders a stub cell used to align summary items in their columns. */
  stubCellComponent?: React_2.ComponentType<TableGroupRow_2.StubCellProps>;
  /** Summary types that the `DataTypeProvider` plugin should not format. */
  formatlessSummaryTypes?: Array<string>;
  /** Localization messages. */
  messages?: TableGroupRow_2.LocalizationMessages;
  /** The group indent column's width. */
  indentColumnWidth?: number;
  /** The group cell's left padding value. */
  contentCellPadding?: string;
}

export declare namespace TableHeaderRow {
  /** Describes properties used to render a table header cell. */
  export type CellProps = TableHeaderRow_2.CellProps;
}

export declare namespace TableHeaderRow {
  /** Describes properties used to render a sort label. */
  export type SortLabelProps = TableHeaderRow_2.SortLabelProps;
}

export declare namespace TableHeaderRow {
  /** Describes properties used to render a cell content. */
  export type ContentProps = TableHeaderRow_2.ContentProps;
}

export declare namespace TableHeaderRow {
  /** Describes properties used to render a group button. */
  export type GroupButtonProps = TableHeaderRow_2.GroupButtonProps;
}

/** A plugin that renders the table's header row. The Column's `title` field specifies the column's title in the header row.The plugin also allows you to manage a column's sorting and grouping state and initiate column dragging. */
export declare const TableHeaderRow: React_2.ComponentType<TableHeaderRowProps> & {
  /** The header row type's identifier. */
  ROW_TYPE: symbol;
} & {
  /** A component that renders a header row. */
  Row: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a header cell. */
  Cell: React_2.ComponentType<TableHeaderRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a cell content. */
  Content: React_2.ComponentType<TableHeaderRow_2.ContentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a sort label. */
  SortLabel: React_2.ComponentType<TableHeaderRow_2.SortLabelProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a title. */
  Title: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group button. */
  GroupButton: React_2.ComponentType<TableHeaderRow_2.GroupButtonProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableHeaderRowProps {
  /** A component that renders a header cell. */
  cellComponent?: React_2.ComponentType<TableHeaderRow_2.CellProps>;
  /** A component that renders a header row. */
  rowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a header cell's content. */
  contentComponent?: React_2.ComponentType<TableHeaderRow_2.ContentProps>;
  /** A component that renders a sort label. */
  sortLabelComponent?: React_2.ComponentType<TableHeaderRow_2.SortLabelProps>;
  /** A component that renders a title. */
  titleComponent?: React_2.ComponentType<object>;
  /** A component that renders a group button. */
  groupButtonComponent?: React_2.ComponentType<TableHeaderRow_2.GroupButtonProps>;
  /** Specifies whether to render controls that toggle the column's sorting state. Requires the SortingState dependency. */
  showSortingControls?: boolean;
  /** Specifies whether to display a button that groups data by column. Requires the GroupingState dependency. */
  showGroupingControls?: boolean;
  /** An object that specifies localization messages. */
  messages?: TableHeaderRow_2.LocalizationMessages;
}

export declare namespace TableInlineCellEditing {
  /** Describes properties passed to a component that renders an editable cell. */
  export type CellProps = TableInlineCellEditing_2.CellProps;
}

/** A plugin that renders a cell being edited. */
export declare const TableInlineCellEditing: React_2.ComponentType<TableInlineCellEditingProps> & {
  /** A component that renders an editable cell. */
  Cell: React_2.ComponentType<TableInlineCellEditing_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableInlineCellEditingProps {
  /** A component that renders an editable cell. */
  cellComponent?: React_2.ComponentType<TableInlineCellEditing_2.CellProps>;
  /** The action that switches a cell to edit mode. */
  startEditAction?: 'click' | 'doubleClick';
  /** Specifies whether cell value should be selected when the cell switches to edit mode. */
  selectTextOnEditStart?: boolean;
}

export declare namespace TableKeyboardNavigation {
  /** Properties passed to the `cellComponent`. */
  export type CellProps = TableKeyboardNavigation_2.CellProps;
}

export declare namespace TableKeyboardNavigation {
  /** Properties passed to the `rowComponent` */
  export type RowProps = TableKeyboardNavigation_2.RowProps;
}

/** A plugin that visualizes a focused table cell. */
export declare const TableKeyboardNavigation: React_2.ComponentType<TableKeyboardNavigationProps> & {
  /** A component that renders the focused cell. */
  Cell: React_2.ComponentType<TableKeyboardNavigation_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the focused row. */
  Row: React_2.ComponentType<TableKeyboardNavigation_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableKeyboardNavigationProps {
  /** Defines a cell that should be initially focused in uncontrolled mode. */
  defaultFocusedCell?: { rowKey: string, columnKey: string };
  /** Defines a cell that should be focused. */
  focusedCell?: { rowKey: string, columnKey: string };
  /** A function that is executed when a cell gets focus. */
  onFocusedCellChange?: (focusedCell: { rowKey: string, columnKey: string }) => void;
  /** A component that renders the focused cell. */
  cellComponent?: React_2.ComponentType<TableKeyboardNavigation_2.CellProps>;
  /** A component that renders the row that contains the focused cell. */
  rowComponent?: React_2.ComponentType<TableKeyboardNavigation_2.RowProps>;
  /** Specifies whether a row should be focused when one of its cells is focused. */
  focusedRowEnabled?: boolean;
}

export declare interface TableProps {
  /** Additional column properties that the plugin can handle. */
  columnExtensions?: Array<Table_2.ColumnExtension>;
  /** A component that renders a table. */
  tableComponent?: React_2.ComponentType<object>;
  /** A component that renders a table head. */
  headComponent?: React_2.ComponentType<object>;
  /** A component that renders a table body. */
  bodyComponent?: React_2.ComponentType<object>;
  /** A component that renders a table footer. */
  footerComponent?: React_2.ComponentType<object>;
  /** A component that renders a table's container. */
  containerComponent?: React_2.ComponentType<object>;
  /** A component that renders a table cell. */
  cellComponent?: React_2.ComponentType<Table_2.DataCellProps>;
  /** A component that renders a table row. */
  rowComponent?: React_2.ComponentType<Table_2.DataRowProps>;
  /** A component that renders a table cell when the table is empty. */
  noDataCellComponent?: React_2.ComponentType<Table_2.NoDataCellProps>;
  /** A component that renders a table row when the table is empty. */
  noDataRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a stub table row if the row type is not recognized. */
  stubRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a stub table cell if the cell value is not provided. */
  stubCellComponent?: React_2.ComponentType<Table_2.CellProps>;
  /** A component that renders a stub header cell if the cell value is not provided. */
  stubHeaderCellComponent?: React_2.ComponentType<Table_2.CellProps>;
  /** An object that specifies the localization messages. */
  messages?: Table_2.LocalizationMessages;
}

export declare namespace TableRowDetail {
  /** Describes properties passed to a component that renders a detail row's content. */
  export type ContentProps = TableRowDetail_2.ContentProps;
}

export declare namespace TableRowDetail {
  /** Describes properties passed to a component that renders a detail cell. */
  export type CellProps = TableRowDetail_2.CellProps;
}

export declare namespace TableRowDetail {
  /** Describes properties passed to a component that renders a detail row. */
  export type RowProps = TableRowDetail_2.RowProps;
}

export declare namespace TableRowDetail {
  /** Describes properties passed to a component that renders a cell containing the expand/collapse control. */
  export type ToggleCellProps = TableRowDetail_2.ToggleCellProps;
}

/** A plugin that renders detail rows. */
export declare const TableRowDetail: React_2.ComponentType<TableRowDetailProps> & {
  /** The detail column type's identifier. */
  COLUMN_TYPE: symbol;
  /** The detail row type's indentifier. */
  ROW_TYPE: symbol;
} & {
  /** A component that renders a detail cell. */
  Cell: React_2.ComponentType<TableRowDetail_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a detail row. */
  Row: React_2.ComponentType<TableRowDetail_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a cell containing the expand/collapse control. */
  ToggleCell: React_2.ComponentType<TableRowDetail_2.ToggleCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableRowDetailProps {
  /** A component that renders the detail row's content within the detail cell. */
  contentComponent?: React_2.ComponentType<TableRowDetail_2.ContentProps>;
  /** A component that renders a detail cell. */
  cellComponent?: React_2.ComponentType<TableRowDetail_2.CellProps>;
  /** A component that renders a detail row. */
  rowComponent?: React_2.ComponentType<TableRowDetail_2.RowProps>;
  /** A component that renders a cell containing the expand/collapse control. */
  toggleCellComponent?: React_2.ComponentType<TableRowDetail_2.ToggleCellProps>;
  /** Specifies the width of the column containing expand/collapse controls. */
  toggleColumnWidth?: number;
  /** Specifies the detail row height. */
  rowHeight?: number;
}

export declare namespace TableSelection {
  /** Describes properties passed to a component that renders a cell containing the Select All checkbox. */
  export type HeaderCellProps = TableSelection_2.HeaderCellProps;
}

export declare namespace TableSelection {
  /** Describes properties passed to a component that renders a cell containing a selection checkbox. */
  export type CellProps = TableSelection_2.CellProps;
}

export declare namespace TableSelection {
  /** Properties passed to the `rowComponent`. */
  export type RowProps = TableSelection_2.RowProps;
}

/** A plugin that visualizes table rows' selection state by rendering selection checkboxes and highlighting the selected rows. */
export declare const TableSelection: React_2.ComponentType<TableSelectionProps> & {
  /** The selection column type's indentifier. */
  COLUMN_TYPE: symbol;
} & {
  /** A component that renders a cell with the selection control inside the heading row. */
  HeaderCell: React_2.ComponentType<TableSelection_2.HeaderCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a cell with selection control. */
  Cell: React_2.ComponentType<TableSelection_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableSelectionProps {
  /** Specifies whether to highlight the selected rows. Note that `Table` plugin's `rowComponent` is ignored in this case. */
  highlightRow?: boolean;
  /** Specifies whether a user can select/deselect a row by clicking it. Note that `Table` plugin's `rowComponent` is ignored in this case. */
  selectByRowClick?: boolean;
  /** Specifies whether to render the Select All checkbox in the header row. */
  showSelectAll?: boolean;
  /** Specifies whether to render the selection column that displays selection checkboxes. */
  showSelectionColumn?: boolean;
  /** A component that renders a selection cell . */
  cellComponent?: React_2.ComponentType<TableSelection_2.CellProps>;
  /** A component that renders a cell containing the Select All checkbox. */
  headerCellComponent?: React_2.ComponentType<TableSelection_2.HeaderCellProps>;
  /** A component that renders a selected row. It is used instead of TableBase.Row when `highlightRow` or `selectByRowClick` is enabled. */
  rowComponent?: React_2.ComponentType<TableSelection_2.RowProps>;
  /** The selection column's width. */
  selectionColumnWidth?: number;
}

export declare namespace TableSummaryRow {
  /** Describes properties passed to a component that renders a cell in a summary row. */
  export type CellProps = TableSummaryRow_2.CellProps;
}

export declare namespace TableSummaryRow {
  /** Describes properties passed to a component that renders a cell's content. */
  export type ContentProps = TableSummaryRow_2.ContentProps;
}

export declare namespace TableSummaryRow {
  /** Describes properties passed to a component that renders an indent used to identify a row's level. */
  export type IndentProps = TableSummaryRow_2.IndentProps;
}

export declare namespace TableSummaryRow {
  /** Describes properties passed to a component that renders a summary item. */
  export type ItemProps = TableSummaryRow_2.ItemProps;
}

/** A plugin that renders table rows that display a total, group, and tree summary. */
export declare const TableSummaryRow: React_2.ComponentType<TableSummaryRowProps> & {
  /** The tree summary row type's indentifier. */
  TREE_ROW_TYPE: symbol;
  /** The group summary row type's indentifier. */
  GROUP_ROW_TYPE: symbol;
  /** The total row type's indentifier. */
  TOTAL_ROW_TYPE: symbol;
} & {
  /** A component that renders a cell within a data row. */
  Cell: React_2.ComponentType<TableSummaryRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders the total summary row. */
  TotalRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group summary row. */
  GroupRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a tree summary row. */
  TreeRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a total summary cell. */
  TotalCell: React_2.ComponentType<TableSummaryRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a group summary cell. */
  GroupCell: React_2.ComponentType<TableSummaryRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a tree summary cell. */
  TreeCell: React_2.ComponentType<TableSummaryRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a summary cell within a tree column. */
  TreeColumnCell: React_2.ComponentType<TableSummaryRow_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a summary cell's content within a tree column. */
  TreeColumnContent: React_2.ComponentType<TableSummaryRow_2.ContentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders an indent used to identify a tree row's level in a tree column. */
  TreeColumnIndent: React_2.ComponentType<TableSummaryRow_2.IndentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a summary item. */
  Item: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableSummaryRowProps {
  /** An array of summary types that the `DataTypeProvider` plugin should not format. */
  formatlessSummaryTypes?: Array<string>;
  /** A component that renders the total summary row. */
  totalRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a group summary row. */
  groupRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a tree summary row. */
  treeRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a total summary cell. */
  totalCellComponent?: React_2.ComponentType<TableSummaryRow_2.CellProps>;
  /** A component that renders a group summary cell. */
  groupCellComponent?: React_2.ComponentType<TableSummaryRow_2.CellProps>;
  /** A component that renders a tree summary cell. */
  treeCellComponent?: React_2.ComponentType<TableSummaryRow_2.CellProps>;
  /** A component that renders a summary cell within a tree column. */
  treeColumnCellComponent?: React_2.ComponentType<TableSummaryRow_2.CellProps>;
  /** A component that renders a summary cell's content within a tree column. */
  treeColumnContentComponent?: React_2.ComponentType<TableSummaryRow_2.ContentProps>;
  /** A component that renders an indent used to identify a tree row level within a tree column. */
  treeColumnIndentComponent?: React_2.ComponentType<TableSummaryRow_2.IndentProps>;
  /** A component that renders a summary item. */
  itemComponent?: React_2.ComponentType<TableSummaryRow_2.ItemProps>;
  /** An object that specifies localization messages. */
  messages?: TableSummaryRow_2.LocalizationMessages;
}

export declare namespace TableTreeColumn {
  /** Describes properties passed to a component that renders a cell within a data row. */
  export type CellProps = TableTreeColumn_2.CellProps;
}

export declare namespace TableTreeColumn {
  /** Describes properties passed to a component that renders a cell's content. */
  export type ContentProps = TableTreeColumn_2.ContentProps;
}

export declare namespace TableTreeColumn {
  /** Describes properties passed to a component that renders an indent used to identify a row level. */
  export type IndentProps = TableTreeColumn_2.IndentProps;
}

export declare namespace TableTreeColumn {
  /** Describes properties passed to a component that renders a button used to controls a row's expanded state. */
  export type ExpandButtonProps = TableTreeColumn_2.ExpandButtonProps;
}

export declare namespace TableTreeColumn {
  /** Describes properties passed to a component that renders a checkbox used to control selection. */
  export type CheckboxProps = TableTreeColumn_2.CheckboxProps;
}

/** A plugin that renders a table column with a toggle button and sorting indicators. */
export declare const TableTreeColumn: React_2.ComponentType<TableTreeColumnProps> & {
  /** A component that renders a cell within a data row. */
  Cell: React_2.ComponentType<TableTreeColumn_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a cell's content. */
  Content: React_2.ComponentType<TableTreeColumn_2.ContentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders an indent used to identify a row level. */
  Indent: React_2.ComponentType<TableTreeColumn_2.IndentProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a button used to controls a row's expanded state. */
  ExpandButton: React_2.ComponentType<TableTreeColumn_2.ExpandButtonProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a checkbox used to control selection. */
  Checkbox: React_2.ComponentType<TableTreeColumn_2.CheckboxProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface TableTreeColumnProps {
  /** The name of a column that should be represented as a tree. */
  for?: string;
  /** A component that renders a cell within a data row. */
  cellComponent?: React_2.ComponentType<TableTreeColumn_2.CellProps>;
  /** A component that renders a cell's content. */
  contentComponent?: React_2.ComponentType<TableTreeColumn_2.ContentProps>;
  /** A component that renders an indent used to identify a row level. */
  indentComponent?: React_2.ComponentType<TableTreeColumn_2.IndentProps>;
  /** A component that renders a button that controls the row's expanded state. */
  expandButtonComponent?: React_2.ComponentType<TableTreeColumn_2.ExpandButtonProps>;
  /** A component that renders a checkbox used to control selection. */
  checkboxComponent?: React_2.ComponentType<TableTreeColumn_2.CheckboxProps>;
  /** Specifies whether to render selection controls. Requires the SelectionState plugin. */
  showSelectionControls?: boolean;
  /** Specifies whether to render Select All checkbox. Requires the IntegratedSelection plugin. */
  showSelectAll?: boolean;
}

export declare namespace Toolbar {
  /** Describes properties passed to a component that renders the toolbar root element. */
  export type RootProps = Toolbar_2.RootProps;
}

/** A plugin that renders the Grid toolbar. */
export declare const Toolbar: React_2.ComponentType<ToolbarProps> & {
  /** A component that renders the toolbar root element. */
  Root: React_2.ComponentType<Toolbar_2.RootProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
};

export declare interface ToolbarProps {
  /** A component that renders the toolbar root element. */
  rootComponent?: React_2.ComponentType<Toolbar_2.RootProps>;
}

export declare namespace VirtualTable {
  /** Describes additional column properties that the plugin can handle. */
  export type ColumnExtension = VirtualTable_2.ColumnExtension;
}

/** A plugin that renders a scrollable table instead of a static table. Contains the VirtualTable.Row and VirtualTable.Cell components that provide ways to customize virtual table rows and columns. These components can be extended by other plugins. */
export declare const VirtualTable: React_2.ComponentType<VirtualTableProps> & {
  /** The data column type's indentifier. */
  COLUMN_TYPE: symbol;
  /** The data row type's indentifier. */
  ROW_TYPE: symbol;
  /** The nodata row type's indentifier. */
  NODATA_ROW_TYPE: symbol;
  /** The top position of the table. Used in scrolling. */
  TOP_POSITION: symbol;
  /** The bottom position of the table. Used in scrolling. */
  BOTTOM_POSITION: symbol;
} & {
  /** A component that renders a table. */
  Table: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table head. */
  TableHead: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table body. */
  TableBody: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a table's container. */
  Container: React_2.ComponentType<object & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** Renders a table data cell. */
  Cell: React_2.ComponentType<Table_2.DataCellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** Renders a table data row. */
  Row: React_2.ComponentType<Table_2.DataRowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** Renders a table cell when the table is empty. */
  NoDataCell: React_2.ComponentType<Table_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** Renders a table row when the table is empty. */
  NoDataRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** A component that renders a stub table row. */
  StubRow: React_2.ComponentType<Table_2.RowProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** Renders a stub table cell. */
  StubCell: React_2.ComponentType<Table_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
  /** Renders a stub table header cell. */
  StubHeaderCell: React_2.ComponentType<Table_2.CellProps & { className?: string; style?: React_2.CSSProperties; [x: string]: any }>;
} & {
/** Scrolls table to a row with the specified ID. */
scrollToRow: (rowId: number | string) => void;
};

export declare interface VirtualTableProps {
  /** The virtual table's height. */
  height?: number | string;
  /** Estimated row height. Specify the average value for a table whose rows have different heights. */
  estimatedRowHeight?: number;
  /** Additional column properties that the plugin can handle. */
  columnExtensions?: Array<VirtualTable_2.ColumnExtension>;
  /** A component that renders a table. */
  tableComponent?: React_2.ComponentType<object>;
  /** A component that renders a table head. */
  headComponent?: React_2.ComponentType<object>;
  /** A component that renders a table body. */
  bodyComponent?: React_2.ComponentType<object>;
  /** A component that renders a table footer. */
  footerComponent?: React_2.ComponentType<object>;
  /** A component that renders a table's container. */
  containerComponent?: React_2.ComponentType<object>;
  /** A component that renders a table cell. */
  cellComponent?: React_2.ComponentType<Table_2.DataCellProps>;
  /** A component that renders a table row. */
  rowComponent?: React_2.ComponentType<Table_2.DataRowProps>;
  /** A component that renders a table cell when the table is empty. */
  noDataCellComponent?: React_2.ComponentType<Table_2.NoDataCellProps>;
  /** A component that renders a table row when the table is empty. */
  noDataRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a stub table row if the row type is not recognized. */
  stubRowComponent?: React_2.ComponentType<Table_2.RowProps>;
  /** A component that renders a stub table cell if the cell value is not provided. */
  stubCellComponent?: React_2.ComponentType<Table_2.CellProps>;
  /** A component that renders a stub header cell if the cell value is not provided. */
  stubHeaderCellComponent?: React_2.ComponentType<Table_2.CellProps>;
  /** An object that specifies the localization messages. */
  messages?: Table_2.LocalizationMessages;
  /** Handles a change of the top row. */
  onTopRowChange?: (rowId: number | string) => void;
  /** A reference to the `VirtualTable` instance */
  ref?: React_2.RefObject<typeof VirtualTable>;
}

export { }
